/* Misc function library module,
   Rick Smereka, Copyright (C) 2003-2004.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, get a copy via the Internet at
   http://gnu.org/copyleft/gpl.html or write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307 USA

   You can contact the author via email at rsmereka@future-lab.com

   Original Linux version Jun/2003, Rick Smereka

   Ported to DOS, 32-bit Windows and QNX V4.x, Jul/2003, Rick Smereka

   Changed all logging calls from 'log_file_date' to 'logman'.
   Mar/2004, Rick Smereka */

#include "stdhead.h"

int rnd(int lowr, int highr)
{
   /* Generate a random number in the range 'lowr' to 'highr'
      (inclusive). Function returns the random number upon
      success, '-1' otherwise. */

   char mname[] = "rnd";
   int result, nhighr, range;

   if (lowr >= highr)
      {
      logman("%s:range[lowr must be less than highr]", mname);
      return(-1);
      }

   if (lowr == 0)
      {
      nhighr = ++highr;
      result = rand() % nhighr;
      }
   else
      {
      range = highr - lowr + 1;
      result = (rand() % range) + lowr;
      }

   return(result);
}
